# shaboundtable_ss_r0.py:  Table that gives upper bounds on Sha for
#                          semistable elliptic curves of rank 0.
# William Stein, 2002

import mfd, time, pari, heegner, constants
num_discs = 1

def shabound(E):
    code = E.code()
    modp_bound = E.modp_gcd_upper_bound()
    if modp_bound == constants.not_computed:
        modp_bound = E.compute_modp_gcd_upper_bound()
    modp_bound = eval(modp_bound[1])
    indexes = E.heegner_indexes_odd()
    if indexes == constants.not_computed:
        indexes = E.compute_heegner_indexes_odd()
    if indexes == constants.not_computed:
        return
    indexes = eval(indexes[0])[0:num_discs+1]
    cmd = "indexes=%s;"%indexes+\
          "g=indexes[1];"\
          "for(i=2,length(indexes),g=gcd(g,indexes[i]));"\
          "g;";
    shabound = pari.pari(cmd)
    cp = E.tamagawa_numbers_odd()
    print code,"\t",shabound,"\t",modp_bound,"\t",indexes,"\t",cp


def table(min, max):
    t0 = time.time()
    for N in range(min,max):
        if pari.issquarefree(N):
            M = mfd.ModSym(N,2)
            for E in M.get_iso_classes():
                if E.dimension() == 1 and E.mwrank() == 0:
                    shabound(E)
    print "total time = ", time.time()-t0

